#include <SPI.h>         // needed for Arduino versions later than 0018
#include <Ethernet.h>
#include <Udp.h> 
#include <XBee.h>


XBee xbee = XBee();

byte mac[] = { 0x00, 0x1D, 0x60, 0xAF, 0x03, 0x32 };
byte ip[]  = { 192, 168, 0, 109 };


unsigned int localPort = 9999;

byte remoteIp[4];        // holds received packet's originating IP
unsigned int remotePort; // holds received packet's originating port

// buffers for receiving and sending data
char packetBuffer[23]; //buffer to hold incoming packet,
char  ReplyBuffer[] = "HTTP/1.1 200 OK";   


int derecha = 0;
int izquierda = 0;
int adelante = 0;
int atras = 0;
int claxon = 0;
int camaraup = 0;
int camarado = 0;
int camaraiz = 0;
int camarade = 0;
int parado = 0;


void setup() {
  Serial.begin(9600);
  Ethernet.begin(mac, ip);  
  Udp.begin(localPort);  
  pinMode(9,OUTPUT);
}

void loop() {
  claxon = 0;
  if (Udp.available()) {
    Udp.readPacket(packetBuffer,23, remoteIp, remotePort);
    packetBuffer[23] = ' ';
    Serial.println(packetBuffer);
    Serial.println(strcmp(packetBuffer,"GET /mov-protocol/camup "));
    if(strcmp(packetBuffer,"GET /mov-protocol/right ") == 0){
      derecha = 1;
      izquierda = 0;
      adelante = 0;
      atras = 0;
    }else if(strcmp(packetBuffer,"GET /mov-protocol/left  ") == 0){
      izquierda = 1;
      derecha = 0;
      adelante = 0;
      atras = 0;
    }else if(strcmp(packetBuffer,"GET /mov-protocol/front ") == 0){
      adelante = 1;
      derecha = 0;
      izquierda = 0;
      atras = 0;
    }else if(strcmp(packetBuffer,"GET /mov-protocol/back  ") == 0){
      atras = 1;
      derecha = 0;
      izquierda = 0;
      adelante = 0;
    }else if(strcmp(packetBuffer,"GET /mov-protocol/stop  ")==0){
      atras = 0;
      derecha = 0;
      izquierda = 0;
      adelante = 0;
    }
    if(strcmp(packetBuffer,"GET /mov-protocol/claxo ") == 0){
       claxon = 1; 
    }
    if(strcmp(packetBuffer,"GET /mov-protocol/camup ") == 0){
       camaraup = 1;
       camarado = 0;
       camaraiz = 0;
       camarade = 0; 
    }else if(strcmp(packetBuffer,"GET /mov-protocol/camdo ") == 0){
       camaraup = 0;
       camarado = 1;
       camaraiz = 0;
       camarade = 0; 
    }else if(strcmp(packetBuffer,"GET /mov-protocol/camle ") == 0){
       camaraup = 0;
       camarado = 0;
       camaraiz = 1;
       camarade = 0; 
    }else if(strcmp(packetBuffer,"GET /mov-protocol/camri ") == 0){
       camaraup = 0;
       camarado = 0;
       camaraiz = 0;
       camarade = 1; 
    }else if(strcmp(packetBuffer,"GET /mov-protocol/camst ") == 0){
       camaraup = 0;
       camarado = 0;
       camaraiz = 0;
       camarade = 0; 
    }else if(strcmp(packetBuffer,"GET /mov-protocol/camce ") == 0){
       camaraup = 1;
       camarado = 1;
       camaraiz = 1;
       camarade = 1;
    } 
  uint8_t payload[] = { izquierda, adelante, atras, derecha, claxon, camaraup, camarado, camaraiz, camarade };
  Tx16Request tx = Tx16Request(0x1234, payload, sizeof(payload));
  TxStatusResponse txStatus = TxStatusResponse();
  xbee.send(tx);
  if (xbee.readPacket(5000)) {
    if (xbee.getResponse().getApiId() == TX_STATUS_RESPONSE) {
      xbee.getResponse().getZBTxStatusResponse(txStatus);
      if (txStatus.getStatus() == SUCCESS) {
        digitalWrite(9,HIGH);
        delay(300);
        digitalWrite(9,LOW);
        delay(300);
        digitalWrite(9,HIGH);
        delay(300);
        digitalWrite(9,LOW);
      }
    }
  }
 }
}
